diff --git a/src/GeometryTest/GeometryTest_SurfaceCommands.cxx b/src/GeometryTest/GeometryTest_SurfaceCommands.cxx
index 5b5636f..f41b4a6 100644
--- a/src/GeometryTest/GeometryTest_SurfaceCommands.cxx
+++ b/src/GeometryTest/GeometryTest_SurfaceCommands.cxx
@@ -36,6 +36,7 @@
 
 
 #include <GeomAdaptor_Surface.hxx>
+#include <GeomAdaptor_HSurface.hxx>
 #include <GeomAdaptor_Curve.hxx>
 #include <Geom2dAdaptor_Curve.hxx>
 
@@ -371,6 +372,36 @@ static Standard_Integer GetSurfaceContinuity( Draw_Interpretor& theDI,
   return 0;
 }
 
+//=======================================================================
+//function : GetResolution
+//purpose  : Returns the resolution of the given surface
+//=======================================================================
+static Standard_Integer GetResolution(Draw_Interpretor& theDI,
+                                      Standard_Integer theNArg,
+                                      const char** theArgv)
+{
+  if (theNArg != 3)
+  {
+    theDI << "Use: surfresolution surface toler \n";
+    return 1;
+  }
+
+  const Standard_Real aTol = Draw::Atof(theArgv[2]);
+
+  Handle(Geom_Surface) aGS = DrawTrSurf::GetSurface(theArgv[1]);
+  if (aGS.IsNull())
+  {
+    theDI << "Argument is not a surface!\n";
+    return 1;
+  }
+
+  Handle(Adaptor3d_HSurface) anAS = new GeomAdaptor_HSurface(aGS);
+  theDI << "Ures = " << anAS->UResolution(aTol) <<
+           "; Vres = " << anAS->VResolution(aTol) << "\n";
+
+  return 0;
+}
+
 
 //=======================================================================
 //function : SurfaceCommands
@@ -425,7 +456,10 @@ void  GeometryTest::SurfaceCommands(Draw_Interpretor& theCommands)
 		  __FILE__,
 		  GetSurfaceContinuity,g);
 
-
+ theCommands.Add("surfresolution",
+                 "surfresolution surface toler: \n\tReturns the resolution of the given surface",
+                 __FILE__,
+                 GetResolution, g);
 }
 
 
diff --git a/src/GeomliteTest/GeomliteTest_CurveCommands.cxx b/src/GeomliteTest/GeomliteTest_CurveCommands.cxx
index 180bae2..7308ba6 100644
--- a/src/GeomliteTest/GeomliteTest_CurveCommands.cxx
+++ b/src/GeomliteTest/GeomliteTest_CurveCommands.cxx
@@ -1842,7 +1842,46 @@ static Standard_Integer length(Draw_Interpretor& di,
   return 0;
 }
 
+//=======================================================================
+//function : Polyline2D
+//purpose  : Builds 2D-polygon from set of points. These points will 
+//            be joined by linear segments.
+//=======================================================================
+static Standard_Integer Polyline2D(Draw_Interpretor& theDI,
+                                   Standard_Integer theNArg,
+                                   const char** theArgVal)
+{
+  if (theNArg < 6)
+  {
+    //                0         1     2   3   4   5
+    theDI << "Use: 2dpolyline result px1 py1 px2 py2 ...";
+    return 1;
+  }
+
+  const Standard_Integer aDegree = 1;
+  const Standard_Integer aNbPoles = (theNArg - 2) / 2;
+  TColStd_Array1OfReal anArrOfKnots(1, aNbPoles);
+  TColStd_Array1OfInteger anArrOfMults(1, aNbPoles);
+  TColgp_Array1OfPnt2d anArrOfPoles(1, aNbPoles);
 
+  const Standard_Integer anArgMax = theNArg - 1;
+  for (Standard_Integer aCurrArg = 1, aPID = 1; aCurrArg < anArgMax; aPID++)
+  {
+    anArrOfKnots(aPID) = aPID;
+    anArrOfMults(aPID) = aDegree;
+    const Standard_Real aX = Draw::Atof(theArgVal[++aCurrArg]);
+    const Standard_Real aY = Draw::Atof(theArgVal[++aCurrArg]);
+    anArrOfPoles(aPID).SetCoord(aX, aY);
+  }
+
+  anArrOfMults(anArrOfMults.Lower())++;
+  anArrOfMults(anArrOfMults.Upper())++;
+
+  const Handle(Geom2d_BSplineCurve) aCurv = new Geom2d_BSplineCurve(anArrOfPoles, anArrOfKnots, anArrOfMults, aDegree);
+  DrawTrSurf::Set(theArgVal[1], aCurv);
+
+  return 0;
+}
 
 //=======================================================================
 //function : CurveCommands
@@ -2079,6 +2118,7 @@ void  GeomliteTest::CurveCommands(Draw_Interpretor& theCommands)
 		  __FILE__,
 		  canceldenom,g);
 
- 
+  theCommands.Add("2dpolyline", "2dpolyline result px1 py1 px2 py2 ...",
+                  __FILE__, Polyline2D, g);
 
 }
diff --git a/src/HLRBRep/HLRBRep_Data.cxx b/src/HLRBRep/HLRBRep_Data.cxx
index 72e8f07..71d86cd 100644
--- a/src/HLRBRep/HLRBRep_Data.cxx
+++ b/src/HLRBRep/HLRBRep_Data.cxx
@@ -1941,7 +1941,7 @@ HLRBRep_Data::Classify (const Standard_Integer E,
             GeomInt::AdjustPeriodic(v, VMin, VMax, PeriodV, v, aDummyShift);
 	  
           gp_Pnt2d pnt2d(u, v);
-          if (myClassifier->Classify(pnt2d, Precision::PConfusion())
+          if (myClassifier->Classify(pnt2d, Precision::Confusion())
             != TopAbs_OUT)
           {
             state = TopAbs_IN;
diff --git a/src/IntCurvesFace/IntCurvesFace_Intersector.cxx b/src/IntCurvesFace/IntCurvesFace_Intersector.cxx
index 2893608..9e9fa68 100644
--- a/src/IntCurvesFace/IntCurvesFace_Intersector.cxx
+++ b/src/IntCurvesFace/IntCurvesFace_Intersector.cxx
@@ -228,7 +228,6 @@ void IntCurvesFace_Intersector::InternalCall(const IntCurveSurface_HInter &HICS,
     //Calculate tolerance for 2d classifier
     Standard_Real mintol3d = BRep_Tool::Tolerance(face);
     Standard_Real maxtol3d = mintol3d;
-    Standard_Real mintol2d = Tol, maxtol2d = Tol;
     TopExp_Explorer anExp(face, TopAbs_EDGE);
     for(; anExp.More(); anExp.Next())
     {
@@ -236,24 +235,20 @@ void IntCurvesFace_Intersector::InternalCall(const IntCurveSurface_HInter &HICS,
       mintol3d = Min(mintol3d, curtol);
       maxtol3d = Max(maxtol3d, curtol);
     }
-    Standard_Real minres = Max(Hsurface->UResolution(mintol3d), Hsurface->VResolution(mintol3d));
-    Standard_Real maxres = Max(Hsurface->UResolution(maxtol3d), Hsurface->VResolution(maxtol3d));
-    mintol2d = Max(minres, Tol); 
-    maxtol2d = Max(maxres, Tol);
-    //
+
     Handle(BRepTopAdaptor_TopolTool) anAdditionalTool;
     for(Standard_Integer index=HICS.NbPoints(); index>=1; index--) {  
       const IntCurveSurface_IntersectionPoint& HICSPointindex = HICS.Point(index);
       gp_Pnt2d Puv(HICSPointindex.U(),HICSPointindex.V());
 
       //TopAbs_State currentstate = myTopolTool->Classify(Puv,Tol);
-      TopAbs_State currentstate = myTopolTool->Classify(Puv, !myUseBoundTol ? 0 : mintol2d);
-      if(myUseBoundTol && currentstate == TopAbs_OUT && maxtol2d > mintol2d) {
+      TopAbs_State currentstate = myTopolTool->Classify(Puv, !myUseBoundTol ? 0 : mintol3d);
+      if(myUseBoundTol && currentstate == TopAbs_OUT) {
         if(anAdditionalTool.IsNull())
         {
           anAdditionalTool = new BRepTopAdaptor_TopolTool(Hsurface);
         }
-        currentstate = anAdditionalTool->Classify(Puv,maxtol2d);
+        currentstate = anAdditionalTool->Classify(Puv, maxtol3d);
         if(currentstate == TopAbs_ON)
         {
           currentstate = TopAbs_OUT;
@@ -489,7 +484,7 @@ Bnd_Box IntCurvesFace_Intersector::Bounding() const {
   }
 }
 TopAbs_State IntCurvesFace_Intersector::ClassifyUVPoint(const gp_Pnt2d& Puv) const { 
-  TopAbs_State state = myTopolTool->Classify(Puv,1e-7);
+  TopAbs_State state = myTopolTool->Classify(Puv,Precision::Confusion());
   return(state);
 }
 //============================================================================
diff --git a/src/IntPatch/IntPatch_ImpPrmIntersection.cxx b/src/IntPatch/IntPatch_ImpPrmIntersection.cxx
index 5c74b94..33ea1a7 100644
--- a/src/IntPatch/IntPatch_ImpPrmIntersection.cxx
+++ b/src/IntPatch/IntPatch_ImpPrmIntersection.cxx
@@ -629,29 +629,21 @@ void IntPatch_ImpPrmIntersection::Perform (const Handle(Adaptor3d_HSurface)& Sur
     //plane only touches surface and does not cross it,
     //so no inner points exist.
     SearchIns = Standard_False;
-    Handle(Adaptor3d_TopolTool) T;
-    if(reversed)
-    {
-      T = D1;
-    }
-    else
-    {
-      T = D2;
-    }
+    const Handle(Adaptor3d_TopolTool) anADTT = (reversed) ? D1 : D2;
     Standard_Integer aNbSamples = 0;
-    aNbSamples = T->NbSamples();
+    aNbSamples = anADTT->NbSamples();
     gp_Pnt2d s2d;
     gp_Pnt s3d;
     Standard_Real aValf[1], aUVap[2];
     math_Vector Valf(aValf,1,1), UVap(aUVap,1,2);
-    T->SamplePoint(1,s2d, s3d);
+    anADTT->SamplePoint(1, s2d, s3d);
     UVap(1)=s2d.X(); 
     UVap(2)=s2d.Y();
     Func.Value(UVap,Valf);
     Standard_Real rvalf = Sign(1.,Valf(1));
     for(Standard_Integer i = 2; i <= aNbSamples; ++i)
     {
-      T->SamplePoint(i,s2d, s3d);
+      anADTT->SamplePoint(i, s2d, s3d);
       UVap(1)=s2d.X(); 
       UVap(2)=s2d.Y();
       Func.Value(UVap,Valf);
diff --git a/src/IntStart/IntStart_SearchInside.gxx b/src/IntStart/IntStart_SearchInside.gxx
index 53a2225..c9e1cb1 100644
--- a/src/IntStart/IntStart_SearchInside.gxx
+++ b/src/IntStart/IntStart_SearchInside.gxx
@@ -72,15 +72,6 @@ void IntStart_SearchInside::Perform (TheFunction& Func,
   
   Standard_Real toler1 = toler(1) = ThePSurfaceTool::UResolution(PS,Precision::Confusion());
   Standard_Real toler2 = toler(2) = ThePSurfaceTool::VResolution(PS,Precision::Confusion());
-  Standard_Real Maxtoler1toler2 = toler1;
-  if(toler2>Maxtoler1toler2) Maxtoler1toler2 = toler2;
-
-  //-- lbr le 15 mai 97
-  //-- on interdit aux points d'etre trop prets des restrictions 
-  Maxtoler1toler2*=1000;
-  if(Maxtoler1toler2>du*0.001) Maxtoler1toler2=du*0.001;
-  if(Maxtoler1toler2>dv*0.001) Maxtoler1toler2=dv*0.001;
-  
   
   Func.Set(PS);
   Standard_Real Tol = Func.Tolerance();
@@ -199,15 +190,17 @@ void IntStart_SearchInside::Perform (TheFunction& Func,
 		testpnt = (j <= nbpt);
 	      }
 	    }
-	    if (j > nbpt) {
-	      //	    situ = TheSITool::Classify(PS,UVap(1),UVap(2));
-	      situ = T->Classify(gp_Pnt2d(UVap(1),UVap(2)),
-				 Maxtoler1toler2,Standard_False);   //-- ,Standard_False pour ne pas recadrer on Periodic
-	      if (situ == TopAbs_IN) {
-		list.Append(IntSurf_InteriorPoint(psol,UVap(1),UVap(2),
-						  Func.Direction3d(),
-						  Func.Direction2d()));
-	      }
+            if (j > nbpt)
+            {
+              //Standard_False pour ne pas recadrer on Periodic
+              situ = T->Classify(gp_Pnt2d(UVap(1), UVap(2)),
+                                    Precision::Confusion(), Standard_False);
+              if (situ == TopAbs_IN)
+              {
+                list.Append(IntSurf_InteriorPoint(psol, UVap(1), UVap(2),
+                                                  Func.Direction3d(),
+                                                  Func.Direction2d()));
+              }
 	    }
 	  }
 	}
diff --git a/src/IntTools/FILES b/src/IntTools/FILES
index 6917e7b..59d8222 100644
--- a/src/IntTools/FILES
+++ b/src/IntTools/FILES
@@ -38,8 +38,6 @@ IntTools_EdgeFace.cxx
 IntTools_EdgeFace.hxx
 IntTools_FaceFace.cxx
 IntTools_FaceFace.hxx
-IntTools_FClass2d.cxx
-IntTools_FClass2d.hxx
 IntTools_ListIteratorOfListOfBox.hxx
 IntTools_ListIteratorOfListOfCurveRangeSample.hxx
 IntTools_ListIteratorOfListOfSurfaceRangeSample.hxx
@@ -80,5 +78,5 @@ IntTools_Tools.cxx
 IntTools_Tools.hxx
 IntTools_TopolTool.cxx
 IntTools_TopolTool.hxx
+IntTools_WLineTool.cxx
 IntTools_WLineTool.hxx
-IntTools_WLineTool.cxx
\ No newline at end of file
diff --git a/src/IntTools/IntTools.hxx b/src/IntTools/IntTools.hxx
index 853c126..a052cb3 100644
--- a/src/IntTools/IntTools.hxx
+++ b/src/IntTools/IntTools.hxx
@@ -35,7 +35,6 @@ class IntTools_CommonPrt;
 class IntTools_Root;
 class IntTools_EdgeEdge;
 class IntTools_EdgeFace;
-class IntTools_FClass2d;
 class IntTools_MarkedRangeSet;
 class IntTools_BaseRangeSample;
 class IntTools_CurveRangeSample;
@@ -107,7 +106,6 @@ friend class IntTools_CommonPrt;
 friend class IntTools_Root;
 friend class IntTools_EdgeEdge;
 friend class IntTools_EdgeFace;
-friend class IntTools_FClass2d;
 friend class IntTools_MarkedRangeSet;
 friend class IntTools_BaseRangeSample;
 friend class IntTools_CurveRangeSample;
diff --git a/src/IntTools/IntTools_Context.cxx b/src/IntTools/IntTools_Context.cxx
index 010425c..64ad3b1 100644
--- a/src/IntTools/IntTools_Context.cxx
+++ b/src/IntTools/IntTools_Context.cxx
@@ -19,6 +19,7 @@
 #include <BRepAdaptor_Surface.hxx>
 #include <BRepBndLib.hxx>
 #include <BRepClass3d_SolidClassifier.hxx>
+#include <BRepTopAdaptor_FClass2d.hxx>
 #include <Extrema_LocateExtPC.hxx>
 #include <Geom2d_Curve.hxx>
 #include <Geom2d_TrimmedCurve.hxx>
@@ -33,7 +34,6 @@
 #include <gp_Pnt2d.hxx>
 #include <IntTools_Context.hxx>
 #include <IntTools_Curve.hxx>
-#include <IntTools_FClass2d.hxx>
 #include <IntTools_SurfaceRangeLocalizeData.hxx>
 #include <IntTools_Tools.hxx>
 #include <Precision.hxx>
@@ -103,13 +103,13 @@ IntTools_Context::~IntTools_Context()
   DataMapOfShapeAddress::Iterator aIt;
   DataMapOfTransientAddress::Iterator aIt1;
   //
-  IntTools_FClass2d* pFClass2d;
+  BRepTopAdaptor_FClass2d* pFClass2d;
   //
   aIt.Initialize(myFClass2dMap);
   for (; aIt.More(); aIt.Next()) {
     anAdr=aIt.Value();
-    pFClass2d=(IntTools_FClass2d*)anAdr;
-    (*pFClass2d).~IntTools_FClass2d();
+    pFClass2d = (BRepTopAdaptor_FClass2d*)anAdr;
+    (*pFClass2d).~BRepTopAdaptor_FClass2d();
     myAllocator->Free(anAdr); 
   }
   myFClass2dMap.Clear();
@@ -254,28 +254,23 @@ Standard_Boolean IntTools_Context::IsInfiniteFace
 //function : FClass2d
 //purpose  : 
 //=======================================================================
-IntTools_FClass2d& IntTools_Context::FClass2d(const TopoDS_Face& aF)
+BRepTopAdaptor_FClass2d& IntTools_Context::FClass2d(const TopoDS_Face& aF)
 {
-  Standard_Address anAdr;
-  IntTools_FClass2d* pFClass2d;
+  BRepTopAdaptor_FClass2d* pFClass2d;
   //
   if (!myFClass2dMap.IsBound(aF)) {
-    Standard_Real aTolF;
-    TopoDS_Face aFF;
-    //
-    aFF=aF;
-    aFF.Orientation(TopAbs_FORWARD);
-    aTolF=BRep_Tool::Tolerance(aFF);
-    //
-    pFClass2d=(IntTools_FClass2d*)myAllocator->Allocate(sizeof(IntTools_FClass2d));
-    new (pFClass2d) IntTools_FClass2d(aFF, aTolF);
+    const TopoDS_Face aFF = TopoDS::Face(aF.Oriented(TopAbs_FORWARD));
+    const Standard_Real aTolF=BRep_Tool::Tolerance(aFF);
     //
-    anAdr=(Standard_Address)pFClass2d;
-    myFClass2dMap.Bind(aFF, anAdr);
+    pFClass2d = (BRepTopAdaptor_FClass2d*)myAllocator->
+                        Allocate(sizeof(BRepTopAdaptor_FClass2d));
+    new (pFClass2d)BRepTopAdaptor_FClass2d(aFF, aTolF);
+
+    myFClass2dMap.Bind(aFF, (Standard_Address)pFClass2d);
   }
-  else {
-    anAdr=myFClass2dMap.Find(aF);
-    pFClass2d=(IntTools_FClass2d*)anAdr;
+  else
+  {
+    pFClass2d = (BRepTopAdaptor_FClass2d*)(myFClass2dMap.Find(aF));
   }
   return *pFClass2d;
 }
@@ -703,12 +698,11 @@ Standard_Integer IntTools_Context::ComputeVF
 //function : StatePointFace
 //purpose  : 
 //=======================================================================
-TopAbs_State IntTools_Context::StatePointFace
-  (const TopoDS_Face& aF,
-   const gp_Pnt2d& aP2d)
+TopAbs_State IntTools_Context::StatePointFace(const TopoDS_Face& aF,
+                                              const gp_Pnt2d& aP2d)
 {
   TopAbs_State aState;
-  IntTools_FClass2d& aClass2d=FClass2d(aF);
+  BRepTopAdaptor_FClass2d& aClass2d = FClass2d(aF);
   aState=aClass2d.Perform(aP2d);
   return aState;
 }
diff --git a/src/IntTools/IntTools_Context.hxx b/src/IntTools/IntTools_Context.hxx
index 3ec1dcf..9f9e7ad 100644
--- a/src/IntTools/IntTools_Context.hxx
+++ b/src/IntTools/IntTools_Context.hxx
@@ -29,7 +29,6 @@
 #include <Standard_Boolean.hxx>
 #include <BRepAdaptor_Surface.hxx>
 #include <TColStd_MapTransientHasher.hxx>
-class IntTools_FClass2d;
 class TopoDS_Face;
 class GeomAPI_ProjectPointOnSurf;
 class GeomAPI_ProjectPointOnCurve;
@@ -37,6 +36,7 @@ class TopoDS_Edge;
 class Geom_Curve;
 class IntTools_SurfaceRangeLocalizeData;
 class BRepClass3d_SolidClassifier;
+class BRepTopAdaptor_FClass2d;
 class TopoDS_Solid;
 class Geom2dHatch_Hatcher;
 class gp_Pnt;
@@ -64,7 +64,7 @@ Standard_EXPORT virtual  ~IntTools_Context();
 
   //! Returns a reference to point classifier
   //! for given face
-  Standard_EXPORT IntTools_FClass2d& FClass2d (const TopoDS_Face& aF);
+  Standard_EXPORT BRepTopAdaptor_FClass2d& FClass2d(const TopoDS_Face& aF);
   
 
   //! Returns a reference to point projector
diff --git a/src/IntTools/IntTools_EdgeEdge.cxx b/src/IntTools/IntTools_EdgeEdge.cxx
index 38c3646..04cffb3 100644
--- a/src/IntTools/IntTools_EdgeEdge.cxx
+++ b/src/IntTools/IntTools_EdgeEdge.cxx
@@ -888,20 +888,6 @@ void IntTools_EdgeEdge::ComputeLineLine()
     return;
   }
   //
-  {
-    TopoDS_Iterator aIt1, aIt2;
-    aIt1.Initialize(myEdge1);
-    for (; aIt1.More(); aIt1.Next()) {
-      const TopoDS_Shape& aV1 = aIt1.Value();
-      aIt2.Initialize(myEdge2);
-      for (; aIt2.More(); aIt2.Next()) {
-        const TopoDS_Shape& aV2 = aIt2.Value();
-        if (aV2.IsSame(aV1)) {
-          return;
-        }
-      }
-    }
-  }
   //
   aSin = 1. - aCos*aCos;
   gp_Pnt O1 = aL1.Location();
diff --git a/src/IntTools/IntTools_EdgeFace.cxx b/src/IntTools/IntTools_EdgeFace.cxx
index 36f181e..02a002f 100644
--- a/src/IntTools/IntTools_EdgeFace.cxx
+++ b/src/IntTools/IntTools_EdgeFace.cxx
@@ -18,6 +18,7 @@
 #include <BndLib_AddSurface.hxx>
 #include <BRep_Tool.hxx>
 #include <BRepAdaptor_Surface.hxx>
+#include <BRepTopAdaptor_FClass2d.hxx>
 #include <Extrema_ExtCS.hxx>
 #include <Extrema_POnCurv.hxx>
 #include <Extrema_POnSurf.hxx>
@@ -44,7 +45,6 @@
 #include <IntTools_CommonPrt.hxx>
 #include <IntTools_Context.hxx>
 #include <IntTools_EdgeFace.hxx>
-#include <IntTools_FClass2d.hxx>
 #include <IntTools_Range.hxx>
 #include <IntTools_Root.hxx>
 #include <IntTools_Tools.hxx>
@@ -124,11 +124,11 @@ Standard_Boolean IntTools_EdgeFace::IsCoincident()
     //We classify only three points: in the begin, in the 
     //end and in the middle of the edge.
     //However, exact middle point (when i == (aNbSeg + 1)/2)
-    //can be unprojectable. Therefore, it will not be able to
+    //can be nonprojectable. Therefore, it will not be able to
     //be classified. Therefore, points with indexes in 
     //[aTreshIdxF, aTreshIdxL] range are made available 
     //for classification.
-    //isClassified == TRUE if MIDDLE point has been choosen and
+    //isClassified == TRUE if MIDDLE point has been chosen and
     //classified correctly.
 
     if(((0 < i) && (i < aTreshIdxF)) || ((aTreshIdxL < i ) && (i < aNbSeg)))
@@ -141,7 +141,7 @@ Standard_Boolean IntTools_EdgeFace::IsCoincident()
     aP2d.SetX(aU);
     aP2d.SetY(aV);
 
-    IntTools_FClass2d& aClass2d=myContext->FClass2d(myFace);
+    BRepTopAdaptor_FClass2d& aClass2d = myContext->FClass2d(myFace);
     aState = aClass2d.Perform(aP2d);
     
     if(aState == TopAbs_OUT)
diff --git a/src/IntTools/IntTools_FaceFace.cxx b/src/IntTools/IntTools_FaceFace.cxx
index 96d14a6..de91078 100644
--- a/src/IntTools/IntTools_FaceFace.cxx
+++ b/src/IntTools/IntTools_FaceFace.cxx
@@ -493,10 +493,10 @@ void IntTools_FaceFace::Perform(const TopoDS_Face& aF1,
     myHS2->ChangeSurface().Load(S2, umin, umax, vmin, vmax);
   }
 
-  const Handle(IntTools_TopolTool) dom1 = new IntTools_TopolTool(myHS1);
-  const Handle(IntTools_TopolTool) dom2 = new IntTools_TopolTool(myHS2);
+  const Handle(IntTools_TopolTool) aDom1 = new IntTools_TopolTool(myHS1);
+  const Handle(IntTools_TopolTool) aDom2 = new IntTools_TopolTool(myHS2);
 
-  myLConstruct.Load(dom1, dom2, myHS1, myHS2);
+  myLConstruct.Load(aDom1, aDom2, myHS1, myHS2);
   
 
   Tolerances(myHS1, myHS2, TolTang);
@@ -545,9 +545,9 @@ void IntTools_FaceFace::Perform(const TopoDS_Face& aF1,
 
   const Standard_Boolean isGeomInt = isTreatAnalityc(aBAS1, aBAS2, myTol);
   if (aF1.IsSame(aF2))
-    myIntersector.Perform(myHS1, dom1, TolArc, TolTang);
+    myIntersector.Perform(myHS1, aDom1, TolArc, TolTang);
   else
-    myIntersector.Perform(myHS1, dom1, myHS2, dom2, TolArc, TolTang, 
+    myIntersector.Perform(myHS1, aDom1, myHS2, aDom2, TolArc, TolTang, 
                           myListOfPnts, isGeomInt);
 
   myIsDone = myIntersector.IsDone();
@@ -561,7 +561,7 @@ void IntTools_FaceFace::Perform(const TopoDS_Face& aF1,
     //
     const Standard_Integer aNbLinIntersector = myIntersector.NbLines();
     for (Standard_Integer i=1; i <= aNbLinIntersector; ++i) {
-      MakeCurve(i, dom1, dom2, TolArc);
+      MakeCurve(i, aDom1, aDom2, TolArc);
     }
     //
     ComputeTolReached3d();
@@ -704,8 +704,8 @@ void IntTools_FaceFace::ComputeTolReached3d()
 //purpose  : 
 //=======================================================================
 void IntTools_FaceFace::MakeCurve(const Standard_Integer Index,
-                                  const Handle(Adaptor3d_TopolTool)& dom1,
-                                  const Handle(Adaptor3d_TopolTool)& dom2,
+                                  const Handle(Adaptor3d_TopolTool)& theDom1,
+                                  const Handle(Adaptor3d_TopolTool)& theDom2,
                                   const Standard_Real theToler) 
 {
   Standard_Boolean bDone, rejectSurface, reApprox, bAvoidLineConstructor;
@@ -870,13 +870,12 @@ void IntTools_FaceFace::MakeCurve(const Standard_Integer Index,
           continue;
         }
 
-        Standard_Real u1, v1, u2, v2, Tol;
-        
-        Tol = Precision::Confusion();
+        Standard_Real u1, v1, u2, v2;
+
         Parameters(myHS1, myHS2, ptref,  u1, v1, u2, v2);
-        ok = (dom1->Classify(gp_Pnt2d(u1, v1), Tol) != TopAbs_OUT);
+        ok = (theDom1->Classify(gp_Pnt2d(u1, v1), Precision::Confusion()) != TopAbs_OUT);
         if(ok) { 
-          ok = (dom2->Classify(gp_Pnt2d(u2,v2),Tol) != TopAbs_OUT); 
+          ok = (theDom2->Classify(gp_Pnt2d(u2, v2), Precision::Confusion()) != TopAbs_OUT);
         }
         if (ok) {
           Handle(Geom2d_BSplineCurve) H1;
@@ -1032,18 +1031,17 @@ void IntTools_FaceFace::MakeCurve(const Standard_Integer Index,
           }
         }
         //
-        Standard_Real aTwoPIdiv17, u1, v1, u2, v2, Tol;
+        Standard_Real aTwoPIdiv17, u1, v1, u2, v2;
 
         aTwoPIdiv17=2.*M_PI/17.;
 
         for (j=0; j<=17; j++) {
           gp_Pnt ptref (newc->Value (j*aTwoPIdiv17));
-          Tol = Precision::Confusion();
 
           Parameters(myHS1, myHS2, ptref, u1, v1, u2, v2);
-          ok = (dom1->Classify(gp_Pnt2d(u1,v1),Tol) != TopAbs_OUT);
+          ok = (theDom1->Classify(gp_Pnt2d(u1, v1), Precision::Confusion()) != TopAbs_OUT);
           if(ok) { 
-            ok = (dom2->Classify(gp_Pnt2d(u2,v2),Tol) != TopAbs_OUT);
+            ok = (theDom2->Classify(gp_Pnt2d(u2, v2), Precision::Confusion()) != TopAbs_OUT);
           }
           if (ok) {
             IntTools_Curve aCurve;
diff --git a/src/IntTools/IntTools_Tools.cxx b/src/IntTools/IntTools_Tools.cxx
index 46c891d..7c8a6d4 100644
--- a/src/IntTools/IntTools_Tools.cxx
+++ b/src/IntTools/IntTools_Tools.cxx
@@ -19,6 +19,7 @@
 #include <BRep_Tool.hxx>
 #include <BRepAdaptor_Curve.hxx>
 #include <BRepAdaptor_Surface.hxx>
+#include <BRepTopAdaptor_FClass2d.hxx>
 #include <Geom2d_Curve.hxx>
 #include <Geom2d_TrimmedCurve.hxx>
 #include <Geom_BoundedCurve.hxx>
@@ -41,7 +42,6 @@
 #include <gp_Pnt2d.hxx>
 #include <IntTools_CommonPrt.hxx>
 #include <IntTools_Curve.hxx>
-#include <IntTools_FClass2d.hxx>
 #include <IntTools_Range.hxx>
 #include <IntTools_SequenceOfCurves.hxx>
 #include <IntTools_Tools.hxx>
@@ -430,14 +430,11 @@ static
 //purpose  : 
 //=======================================================================
   TopAbs_State IntTools_Tools::ClassifyPointByFace(const TopoDS_Face& aF,
-         const gp_Pnt2d& aP2d)
+                                                   const gp_Pnt2d& aP2d)
 {
-  Standard_Real aFaceTolerance;
-  TopAbs_State aState;
-  
-  aFaceTolerance=BRep_Tool::Tolerance(aF);
-  IntTools_FClass2d aClass2d(aF, aFaceTolerance);
-  aState=aClass2d.Perform(aP2d);
+  const Standard_Real aTolF=BRep_Tool::Tolerance(aF);
+  BRepTopAdaptor_FClass2d aClass2d(aF, aTolF);
+  const TopAbs_State aState=aClass2d.Perform(aP2d);
   
   return aState;
 }
diff --git a/src/LocOpe/LocOpe_FindEdgesInFace.cxx b/src/LocOpe/LocOpe_FindEdgesInFace.cxx
index 1dbc5c9..5eb1ea1 100644
--- a/src/LocOpe/LocOpe_FindEdgesInFace.cxx
+++ b/src/LocOpe/LocOpe_FindEdgesInFace.cxx
@@ -78,7 +78,6 @@ void LocOpe_FindEdgesInFace::Set(const TopoDS_Shape& Sh,
   }
 
   Handle(BRepAdaptor_HSurface) HS = new BRepAdaptor_HSurface(myFace);
-  BRepTopAdaptor_TopolTool TPT(HS);
 
   for (exp.Init(myShape,TopAbs_EDGE); exp.More(); exp.Next()) {
     ToAdd = Standard_False;
@@ -160,13 +159,15 @@ void LocOpe_FindEdgesInFace::Set(const TopoDS_Shape& Sh,
 	else {
 	  ElSLib::Parameters(cy,p[i],U,V);
 	}
-	if (TPT.Classify(gp_Pnt2d(U,V),Precision::Confusion())== TopAbs_OUT) {
-	  break;
-	}
+        
+        BRepTopAdaptor_TopolTool aTPT(HS);
+        if (aTPT.Classify(gp_Pnt2d(U,V),Precision::Confusion())== TopAbs_OUT) {
+          break;
+        }
       }
       if (i >= 3) { 
-	M.Add(edg);
-	myList.Append(edg);
+        M.Add(edg);
+        myList.Append(edg);
       }
     }
   }
diff --git a/src/LocOpe/LocOpe_SplitShape.cxx b/src/LocOpe/LocOpe_SplitShape.cxx
index 80b896b..dcb3812 100644
--- a/src/LocOpe/LocOpe_SplitShape.cxx
+++ b/src/LocOpe/LocOpe_SplitShape.cxx
@@ -643,7 +643,7 @@ Standard_Boolean LocOpe_SplitShape::AddClosedWire(const TopoDS_Wire& W,
   //  GProp_GProps GP;
   //  BRepGProp::SurfaceProperties (newFace,GP);
   //  if (GP.Mass() < 0) {
-  BRepTopAdaptor_FClass2d classif(newFace,Precision::PConfusion());
+  BRepTopAdaptor_FClass2d classif(newFace, Precision::Confusion());
   if (classif.PerformInfinitePoint() == TopAbs_IN) {
     //le wire donne defini un trou
     aLocalFace = F.EmptyCopied();
@@ -1352,7 +1352,7 @@ static Standard_Boolean IsInside(const TopoDS_Face& F,
   //  GProp_GProps GP;
   //  BRepGProp::SurfaceProperties(newFace,GP);
   //  if (GP.Mass() < 0) {
-  BRepTopAdaptor_FClass2d classif(newFace,Precision::PConfusion());
+  BRepTopAdaptor_FClass2d classif(newFace,Precision::Confusion());
   Standard_Boolean Reversed = Standard_False;
   if (classif.PerformInfinitePoint() == TopAbs_IN) {
     //le wire donne defini un trou
@@ -1426,7 +1426,7 @@ static Standard_Boolean IsInside(const TopoDS_Face& F,
     gp_Pnt2d pt2d(C2d->Value(prm));
     //  BRepClass_FaceClassifier classif(F,pt2d,Precision::PConfusion());
     //  return (classif.State() != TopAbs_OUT);
-    BRepTopAdaptor_FClass2d classif(F,Precision::PConfusion());
+    BRepTopAdaptor_FClass2d classif(F,Precision::Confusion());
     TopAbs_State stat = classif.Perform(pt2d);
     //  return (classif.Perform(pt2d) != TopAbs_OUT);
     if(stat == TopAbs_OUT) return Standard_False;
diff --git a/src/LocOpe/LocOpe_WiresOnShape.cxx b/src/LocOpe/LocOpe_WiresOnShape.cxx
index d463cf9..e6ef814 100644
--- a/src/LocOpe/LocOpe_WiresOnShape.cxx
+++ b/src/LocOpe/LocOpe_WiresOnShape.cxx
@@ -1516,7 +1516,7 @@ Standard_Boolean LocOpe_WiresOnShape::Add(const TopTools_SequenceOfShape& theEdg
 
         if (aCheckStateTool.IsNull())
         {
-          aCheckStateTool = new BRepTopAdaptor_FClass2d(aCurF, Precision::PConfusion());
+          aCheckStateTool = new BRepTopAdaptor_FClass2d(aCurF, Precision::Confusion());
         }
         if (aCheckStateTool->Perform(gp_Pnt2d(aU, aV)) == TopAbs_IN)
         {
